using System;
using System.Collections;
using System.Text;

namespace ImageGallery
{
    public class ImageCollection : CollectionBase
    {
        /// <summary>
        /// Indexer property the image
        /// </summary>
        /// <param name="index"></param>
        /// <returns></returns>
        public Image this[int index]
        {
            get
            {
                return (Image)this.List[index];
            }
            set
            {
                this.List[index] = value;
            }
        }

        /// <summary>
        /// Function to add Image in the list.
        /// </summary>
        /// <param name="image">image</param>
        public void Add(Image image)
        {
            image.Index = this.List.Count;
            this.List.Add(image);
        }

        /// <summary>
        /// Function to insert image in specific index.
        /// </summary>
        /// <param name="index">index number</param>
        /// <param name="image">image</param>
        public void Insert(int index, Image image)
        {
            this.List.Insert(index, image);
        }

        /// <summary>
        /// Function to remove image from list.
        /// </summary>
        /// <param name="image">image</param>
        public void Remove(Image image)
        {
            this.List.Remove(image);
        }

        /// <summary>
        /// Function to check is this list contains that image
        /// </summary>
        /// <param name="image">image</param>
        /// <returns>true if list contains the image</returns>
        public bool Contains(Image image)
        {
            return this.List.Contains(image);
        }

        /// <summary>
        /// Function to get the index of Image from list.
        /// </summary>
        /// <param name="image">image</param>
        /// <returns>index</returns>
        public int IndexOf(Image image)
        {
            return this.List.IndexOf(image);

        }

        /// <summary>
        /// Function to copy the element in Array strat from specific index.
        /// </summary>
        /// <param name="array">array</param>
        /// <param name="index">index</param>
        public void CopyTo(Array array, int index)
        {
            this.List.CopyTo(array, index);
        }

    }


}
