using System;
using System.Text;
using System.Web;
using System.Web.UI;

namespace ImageGallery
{
    internal class JavaScript
    {

        #region DATA MEMBERS

        private static string _id = string.Empty;
        private static Gallery gallery = null;

        #endregion

        #region PROPERTIES

        public static Gallery Gallery
        {
            set 
            {
                gallery = value;
                if (gallery != null)
                    _id = gallery.UniqueID; 
            }
        }

        public static string ImageRotatorObjectName
        {
            get { return _id + "_imageRotator";}
        }

        public static string SelectedItemObjectName
        {
            get { return _id + "_SelectedItem"; }
        }

        public static string MouseOutMethodName
        {
            get { return _id + "_MouseOut"; }
        }

        public static string MouseOverMethodName
        {
            get { return _id + "_MouseOver"; }
        }
        
        public static string MouseClickMethodName
        {
            get { return _id + "_MouseClick"; }
        }
        
        public static string ChangeImageMethodName
        {
            get { return _id + "_ChangeImage"; }
        }

        public static string AutoNextMethodName
        {
            get{ return _id + "_AutoNext"; }
        }

        public static string NextImageMethodName
        {
            get { return _id + "_Next"; }
        }

        public static string PreviousImageMethodName
        {
            get { return _id + "_Previous"; }
        }

        #endregion

        #region PUBLIC METHODS

        public static string GetAutoNextMethod()
        {
            
            string timeInterval = (gallery.AutoNextAfter * 1000).ToString();

            StringBuilder strJs = new StringBuilder();
            strJs.Append("function " + AutoNextMethodName + "()" +
                       "{" +
                            "if(" + ImageRotatorObjectName + ".totalImages==0) return;" +
                            "var index =" + ImageRotatorObjectName + ".selectedIndex;" +
                            "index++;" +
                            "if(index>=" + ImageRotatorObjectName + ".totalImages) index=0;");
            if (gallery.ShowNavigationBar)
            {
                strJs.Append("var selBarItem = document.getElementById(" + ImageRotatorObjectName + ".images[index].navBarItemID);" +
                 ChangeImageMethodName + "(index,selBarItem); ");
            }
            else
            {
                strJs.Append(ChangeImageMethodName + "(index); ");
            }
            strJs.Append(" setTimeout(\"" + AutoNextMethodName + "()\"," + timeInterval + ");" +
            "}" +
             " setTimeout(\"" + AutoNextMethodName + "()\"," + timeInterval + ");");

            return strJs.ToString();
        }

        public static string GetNextMethod()
        {
            

            StringBuilder strJs = new StringBuilder();
            strJs.Append("function " + NextImageMethodName + "()" +
                       "{" +
                            "if(" + ImageRotatorObjectName + ".totalImages==0) return;" +
                            "var index =" + ImageRotatorObjectName + ".selectedIndex;" +
                            "index++;" +
                            "if(index>=" + ImageRotatorObjectName + ".totalImages) return;");
            if (gallery.ShowNavigationBar)
            {
                strJs.Append("var selBarItem = document.getElementById(" + ImageRotatorObjectName + ".images[index].navBarItemID);" +
                 ChangeImageMethodName + "(index,selBarItem); ");
            }
            else
            {
                strJs.Append(ChangeImageMethodName + "(index); ");
            }
            strJs.Append("}" );

            return strJs.ToString();
        }

        public static string GetPreviousMethod()
        {
            StringBuilder strJs = new StringBuilder();
            strJs.Append("function " + PreviousImageMethodName + "()" +
                       "{" +
                            "if(" + ImageRotatorObjectName + ".totalImages==0) return;" +
                            "var index =" + ImageRotatorObjectName + ".selectedIndex;" +
                            "index--;" +
                            "if(index<0) return;");
            if (gallery.ShowNavigationBar)
            {
                strJs.Append("var selBarItem = document.getElementById(" + ImageRotatorObjectName + ".images[index].navBarItemID);" +
                 ChangeImageMethodName + "(index,selBarItem); ");
            }
            else
            {
                strJs.Append(ChangeImageMethodName + "(index); ");
            }
            strJs.Append("}");

            return strJs.ToString();
        }

        public static string GetSelectImageFunction()
        {
            StringBuilder strJava = new StringBuilder();
            if (gallery.ShowNavigationBar)
            {
                strJava.Append("function " + ChangeImageMethodName + "(index, item){");
            }
            else
            {
                strJava.Append("function " + ChangeImageMethodName + "(index){");
            }
            switch (gallery.ImageChangeStyle)
            {
                case ImageChangeStyle.Opacity:
                    {
                        strJava.Append(ImageRotatorObjectName + ".displayImageByOpacity(index);");
                        break;
                    }
                default:
                    {
                        strJava.Append(ImageRotatorObjectName + ".displayImage(index);");
                        break;
                    }
            }

            if (gallery.ShowNavigationBar)
            {
                strJava.Append(MouseClickMethodName + "(item);");
            }
            strJava.Append("}");

            return strJava.ToString();
        }

        public static string GetMouseOutFunction()
        {
            return " function " + MouseOutMethodName + "(item){if(" + SelectedItemObjectName + "!=item){item.className = '" +
            gallery.CssClassName + "';}}";
        }

        public static string GetMouseOverFunction()
        {
            return
                " function " + MouseOverMethodName  + "(item){if(" + SelectedItemObjectName + "!=item){item.className = '" +
                gallery.CssHoverClassName + "';}}";
        }

        public static string GetMouseClickFunction()
        {
            StringBuilder strJava = new StringBuilder();
            strJava.Append(" function " + MouseClickMethodName + "(item)");
            strJava.Append("{");

            if (!gallery.NavigationItemBarSelectedItemStyle.IsEmpty)
            {
                strJava.Append("if(" + SelectedItemObjectName + "!= null){" + SelectedItemObjectName + ".className = '" + gallery.CssClassName + "';}");
                strJava.Append("item.className = '" + gallery.CssSelectedClassName + "';");
                strJava.Append(SelectedItemObjectName + " = item;");
            }
            strJava.Append("}");

            return strJava.ToString();


        }

        #endregion 
    }
}
